#include <avr/io.h>
#ifndef HD61202_H
#define HD61202_H 1
#define glcd_DATAPORT			 	PORTC  							// gLCD Data Port
#define glcd_CNTRPORT			 	PORTD  							// gLCD Control Port

#define glcd_DataOut        PORTC 			// gLCD Data Port
#define glcd_DataDir        DDRC		// gLCD Data Direction Port
#define glcd_DataIn         PINC		// gLCD Data Pin Port
#define glcd_sBUSY          7     							// Busy Flag  : 1=active
#define glcd_sONOFF         5     							// OnOff Flag : 1=on,0=off
#define glcd_sRESET         4     							// Reset Flag : 1=active

#define glcd_Control        PORTD 			// gLCD Control Port
#define glcd_ContDir        DDRD  	// gLCD Control Direction
#define glcd_ContIn         PIND 	// gLCD Control Pin Port

#define glcd_RS             6  	//Register select : 1=data reg., 0=instr. reg.
#define glcd_RW             5 	//ReadWrite       : 0=write, 1=read
#define glcd_Enable         7  	//Enable          : 1=active
#define glcd_CS1            4  	//Chip Select 1   : 1=active
#define glcd_CS2            3  	//Chip Select 2   : 1=active
#define glcd_backLED        0  	//BackLight       : 1=active
#define glcd_Reset          2  	//Reset           : 0=active
#define DISPLAY_ON					0x3f
#define DISPLAY_OFF					0x3e
#define DISPLAY_SET_Y       0x40
#define DISPLAY_SET_X       0xb8
#define DISPLAY_START_LINE	0xc0

#define LINE1		0
#define LINE2		1
#define LINE3		2
#define LINE4		3
#define LINE5		4
#define LINE6		5
#define LINE7		6
#define LINE8		7

#define ON			1
#define OFF			0

void glcd_gotoXY(uint8_t x, uint8_t y);  	

void glcd_putc(char chr);               	
void glcd_putS(char *data);             
                                        

void glcd_BackLight(unsigned char a);

void glcd_setDot(uint8_t x, uint8_t y);
void glcd_clrDot(uint8_t x, uint8_t y);
void glcd_startLine(uint8_t start);  // ( 0 : 63 )
void glcd_clrScr(void);

void glcd_drawLine(uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t color);

void glcd_init(void);
void glcd_delay(unsigned int p);
void glcd_waitIfBusy(void);
void glcd_waitIfReset(void);
void glcd_writeCommand(unsigned char Command);
void glcd_writeData(unsigned char Data);
unsigned char glcd_readData(void);
void glcd_setXY(uint8_t x, uint8_t y);
void glcd_rle_picture(const char *progmem_s, uint16_t elements) ;
#endif
