#ifndef LCD_H
#define LCD_H
#define XTAL 4000000

#define LCD_DATA			PORTC
#define LCD_DATA_REVERSE 	1
#define LCD_WR_PORT			PORTA
#define LCD_WR_PIN			3
#define LCD_RD_PORT			PORTA
#define LCD_RD_PIN			4
#define LCD_CE_PORT			PORTA
#define LCD_CE_PIN			5
#define LCD_CD_PORT			PORTA
#define LCD_CD_PIN			6
#define LCD_RST_PORT		PORTA
#define LCD_RST_PIN			7

#define cGraphResX  128
#define cGraphResY  64
#define cTxtResX  21
#define cTxtResY 8
#define cFontWidth 6
#define cGraphColumns 22
#define LCD_GON_TOFF 0x98
#define LCD_GON_TON 0x9f

extern void lcd_command(uint8_t cmd);
extern void lcd_data(uint8_t data);
extern void lcd_data1(uint8_t data, uint8_t cmd);
extern void lcd_data2(uint16_t data, uint8_t cmd);
extern void lcd_setPixel(unsigned char xpos, unsigned char ypos, unsigned char mode);
extern void lcd_init(void);
extern void lcd_clrscr(void);
extern void lcd_clrGraphics(void);
extern void lcd_drawLine(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char color);
extern void lcd_puts_xy(const char *txt, unsigned char xpos, unsigned char ypos);
extern void lcd_puts_xy_p(const char *progmem_s, unsigned char xpos, unsigned char ypos);
#define lcd_puts_xy_P(__s,__x,__y) lcd_puts_xy_p(PSTR(__s),__x,__y)
extern void lcd_dsp_picture_p(const char *progmem_s, uint16_t elements);
#define lcd_dsp_picture_P(__s,__e) lcd_dsp_picture_p(PSTR(__s),__e)
extern void printFormat(unsigned int i);
#endif //LCD_H
