#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "evalboard.h"
#include "lcd.h"
#include "uart.h"

unsigned char address = 0;
unsigned char ticks = 0;

unsigned char checkTaster2(void) {
     unsigned char result = 0;
     DDRC = DDRC & 0x7F;
     DDRD = DDRD & 0x7F;
     PORTC = PORTC | 0x80;
     PORTD = PORTD | 0x80;
     if ((PINC & 0x80) == 0x00) {
         lcd_puts_P("Taster 1        ");
         result = 1;
     }
     if ((PIND & 0x80) == 0x00) {
         lcd_puts_P("Taster 2        " );
         result = 1;         
     }    
}
SIGNAL (SIG_OVERFLOW0) {
//
// Timer0 used for LCD Scrolling Text
//
  char buffer[9];
  char buffer2[9];  
  address++;
  ticks++;
  eeprom_read_block(&buffer, (void *) (message + address), 8);
  eeprom_read_block(&buffer2, (void *) (message + address + 8), 8);
  if (buffer2[7] == 0x00)
    address = 0x00;
  buffer[8] = 0x00;
  buffer2[8] = 0x00;  
  if (checkTaster2()) {
    lcd_gotoxy(0,0);
    lcd_puts(&buffer[0]);
    lcd_gotoxy(0,1);
    lcd_puts(&buffer2[0]);  
  }
  PORTA = PORTA << 1;
  if (PORTA == 0x00)
    PORTA = 0x01;
}    



void init(void) {
  // Init Interrupts
  lcd_init(LCD_DISP_ON);    
  lcd_clrscr();   
  DDRA = 0xff;
  TCCR0 = 0x05;                            // Timer0 Prescaler
  TIMSK = TIMSK | 0x01;                    // Timer0 Enable
  uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,XTAL_CPU) );   
  sei();   
}


int main(void) {
   unsigned int c;
   init();
   while (1) {
     while (ticks < 10) {
       c = uart_getc();
       if (!(c & UART_NO_DATA)) {
         uart_puts_P("Received: " );
         uart_putc( (unsigned char) c);
         uart_puts_P("\r\n");
       }
     }
     ticks = 0;
     uart_puts_P("DELTAWAVE AVR Developer !\r\n");
   }
}
